'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Arr = require('./lib/Arr');

var _Arr2 = _interopRequireDefault(_Arr);

var _TimeRange = require('./TimeRange');

var _TimeRange2 = _interopRequireDefault(_TimeRange);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var OpeningHoursForDay = function () {
    function OpeningHoursForDay() {
        _classCallCheck(this, OpeningHoursForDay);

        this._openingHours = [];
    }

    _createClass(OpeningHoursForDay, [{
        key: 'isOpenAt',
        value: function isOpenAt(time) {
            var _iteratorNormalCompletion = true;
            var _didIteratorError = false;
            var _iteratorError = undefined;

            try {
                for (var _iterator = this.openingHours[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
                    var timeRange = _step.value;

                    if (timeRange.containsTime(time)) {
                        return true;
                    }
                }
            } catch (err) {
                _didIteratorError = true;
                _iteratorError = err;
            } finally {
                try {
                    if (!_iteratorNormalCompletion && _iterator.return) {
                        _iterator.return();
                    }
                } finally {
                    if (_didIteratorError) {
                        throw _iteratorError;
                    }
                }
            }

            return false;
        }
    }, {
        key: '_guardAgainstTimeRangeOverlaps',
        value: function _guardAgainstTimeRangeOverlaps(openingHours) {
            _Arr2.default.createUniquePairs(openingHours).forEach(function (_ref) {
                var _ref2 = _slicedToArray(_ref, 2);

                var rangeA = _ref2[0];
                var rangeB = _ref2[1];

                if (rangeA.overlaps(rangeB)) {
                    throw new Error('Time ranges ' + rangeA + ' and ' + rangeB + ' overlap.');
                }
            });
        }
    }, {
        key: 'openingHours',
        get: function get() {
            return this._openingHours;
        }
    }], [{
        key: 'fromStrings',
        value: function fromStrings(strings) {
            var openingHoursForDay = new OpeningHoursForDay();

            var timeRanges = strings.map(function (string) {
                return _TimeRange2.default.fromString(string);
            });

            openingHoursForDay._guardAgainstTimeRangeOverlaps(timeRanges);

            openingHoursForDay._openingHours = timeRanges;

            return openingHoursForDay;
        }
    }]);

    return OpeningHoursForDay;
}();

exports.default = OpeningHoursForDay;